unit frmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ORCtrls, StdCtrls, ExtCtrls, Menus, jpeg,  OleServer,
  Shellapi, VA508AccessibilityManager, UCore;                //QuickRpt,  Outlook8,

type
  TUserParameters = record
  TEMP_FLD_1_TITLE     : String;
  TEMP_FLD_1_SIZE      : String;
  TEMP_FLD_EXPIRE      : Integer;
  TEMP_FLD_2_TITLE     : String;
  TEMP_FLD_2_SIZE      : String;
  TEMP_FLD_3_TITLE     : String;
  TEMP_FLD_3_SIZE      : String;
  TEMP_FLD_4_TITLE     : String;
  TEMP_FLD_4_SIZE      : String;
  TEMP_FLD_COLOR       : String;
  TEMP_FLD_FONTCOLOR   : String;
  STUDENT              : TStrings;
  RESIDENT             : TStrings;
  DNR_Titles           : TStrings;
  PATIENT_DEMOGRAPHICS : String;
  PATIENT_DEMO_PRINTLBL : integer;
  MED_DETAIL_FLG       : Integer;
  MED_EXCLUDE_IV       : Integer;
  CONSULTS             : Integer;
  LABS_IMAGING         : Integer;
  PRINT_ORIENTATION    : String;
  ORDER_BY             : integer;
  MULTI_DNR            : Integer;
  FILE_Location        : String;

  end;

type
  TfrmListSelect = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    ORLbxPatients: TORListBox;
    DeletePL: TPopupMenu;
    DeletePersonalList: TMenuItem;
    Preference1: TMenuItem;
    Panel3: TPanel;
    DeletePat: TPopupMenu;
    DeletePatientfromList1: TMenuItem;
    Panel4: TPanel;
    PhoneDirectory1: TMenuItem;
    Hand1: TMenuItem;
    Help1: TMenuItem;
    Content1: TMenuItem;
    GetAdditionalInfo1: TMenuItem;
    FeedbackforTool1: TMenuItem;
    Directory1: TMenuItem;
    TeamInfo2: TMenuItem;
    Mailto1: TMenuItem;
    mail1: TMenuItem;
    Email1: TMenuItem;
    AssignProviders: TMenuItem;
    ChangePreference1: TMenuItem;
    AssignPhysiciantoateam1: TMenuItem;
    About1: TMenuItem;
    Edit3: TMenuItem;
    DisplayFont: TMenuItem;
    Font1: TMenuItem;
    N8pt1: TMenuItem;
    N10pt1: TMenuItem;
    N12pt1: TMenuItem;
    N18pt1: TMenuItem;
    N24pt1: TMenuItem;
    btnClearList: TORAlignButton;
    ORAutoPanel1: TORAutoPanel;
    ORAutoPanel2: TORAutoPanel;
    ORAutoPanel3: TORAutoPanel;
    Edit1: TORAlignEdit;
    Edit2: TORAlignEdit;
    pnlChgListOption: TORAutoPanel;
    cboPList: TORComboBox;
    Panel5: TPanel;
    cbNewPersonalList: TCheckBox;
    cbOneTime: TCheckBox;
    cbSavePersonalList: TCheckBox;
    cbSaveHOTeamList: TCheckBox;
    btnSubmit: TORAlignButton;
    btn_Personal: TButton;
    btn_Ward: TButton;
    btn_Provider: TButton;
    btn_Team: TButton;
    btn_Specialty: TButton;
    btn_HOList: TButton;
    btn_Patient: TButton;
    btn_Def_Patient: TButton;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    Panel6: TPanel;
    procedure btn_Def_PatientKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btn_Def_PatientClick(Sender: TObject);
    procedure btn_PatientKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btn_PatientClick(Sender: TObject);
    procedure btn_HOListKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btn_HOListClick(Sender: TObject);
    procedure btn_SpecialtyClick(Sender: TObject);
    procedure btn_SpecialtyKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btn_TeamKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btn_TeamClick(Sender: TObject);
    procedure btn_ProviderKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btn_ProviderClick(Sender: TObject);
    procedure btn_WardClick(Sender: TObject);
    procedure btn_WardKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btn_PersonalKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btn_PersonalClick(Sender: TObject);
    procedure cbSaveHOTeamListClick(Sender: TObject);
    procedure cbSavePersonalListClick(Sender: TObject);
    procedure cbOneTimeClick(Sender: TObject);
    procedure cbNewPersonalListKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cbNewPersonalListClick(Sender: TObject);
    procedure cboPListMouseClick(Sender: TObject);
    procedure cboPListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cboPListKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure cboPListClick(Sender: TObject);
    procedure cboPListDblClick(Sender: TObject);
    procedure cboPListNeedData(Sender: TObject; const StartFrom: String;
      Direction, InsertAt: Integer);
    procedure FormShow(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure DeletePLPopup(Sender: TObject);
    procedure DeletePersonalListClick(Sender: TObject);
    procedure Preference1Click(Sender: TObject);
    procedure ORLbxPatientsDblClick(Sender: TObject);
    procedure btnSubmitClick(Sender: TObject);
    procedure DeletePatientfromList1Click(Sender: TObject);
    procedure btnClearListClick(Sender: TObject);
    procedure Hand1Click(Sender: TObject);
    procedure Content1Click(Sender: TObject);
    procedure GetAdditionalInfo1Click(Sender: TObject);
    procedure Directory1Click(Sender: TObject);
    procedure TeamInfo2Click(Sender: TObject);
    procedure Email1Click(Sender: TObject);
    procedure AssignProvidersClick(Sender: TObject);
    procedure ChangePreference1Click(Sender: TObject);
    procedure File1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure N8pt1Click(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure ORLbxPatientsKeyPress(Sender: TObject; var Key: Char);
    procedure CheckForSensPat(PatList: TStrings);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }

    HLGT : TControl;
    HLGT2: TControl;
    DONOTHING : Boolean;
    TMP_LST : String;
    HOAddPats : TStrings;
    ListModified : Boolean;
    PatientsFound : Boolean;
    ProjectVersion : String;
    ProductName : String;
    procedure SelectList(LN, TL : String ; Patients: TStrings; f : Boolean; indx : integer);
    procedure Changelblcolor(C1,C2 : TControl);
    procedure clearparameters;
    procedure SaveOptions(SelList: String);
    procedure ClearAllRadioButtons;
    procedure ChangeFont(NewFontSize: Integer);
    function IsVersionOK: boolean;
  public
    { Public declarations }
    DUZ :String;
    User : String;
    DTIME : integer;
    TimeOut: integer;
    MGRFLG : Integer;     //1 - Display Perference Page
    MGRHOTFLG : Integer;
    Pref : String;
    vDiv: string;
    UserPar : TUserParameters;
    SelectedList : TStrings;
    CurrentPtLst : String;
    LastPatientAdd : String;
    FontSz : Integer;
    function IsLast5(x: string): Boolean;
    function IsFullSSN(x: string): Boolean;
    procedure SetParameters(TL : TStrings);
    procedure EnableChgPreferenceMenu;
    procedure UpdateMyPref();

  end;

var
  frmListSelect: TfrmListSelect;



implementation

{$R *.DFM}

uses ORNet, Orfn, rcore, rOptions, frmPrintData, Util, Registry,
      fOptionsNewList,  frmTeamRoster, frmHOTeamSelect, frmPreferences, frmTeamI,
      frmAssignPrvTeam, frmAList, frmAbout, VA508AccessibilityRouter, VAUtils, U_HelpMGR;
//fOptionsNewList borrowed from CPRS

procedure TfrmListSelect.FormCreate(Sender: TObject);
var
  tList: TStrings;
  Mi: TMenuItem;
  vList: TStrings;
begin
  ChDir(ExtractFilePath(Application.ExeName));
  frmListSelect.FormStyle := fsStayOnTop;

  if not ConnectToServer('CRHD SHIFT CHANGE HANDOFF') then
  begin
    Close;
    exit;
  end;

  ProjectVersion := FileVersionValue(Application.ExeName, FILE_VER_FILEVERSION);
  ProductName := Application.Title;

  // Version Check
  if not IsVersionOK then
  begin
    Close;
    exit;
  end;

  tList := TStringList.Create;
  try
    if HOAddPats = nil then
      HOAddPats := TStringList.Create;
    vDiv := RPCBrokerV.User.Division;
    tCallV(tList, 'CRHD GET USER DIVISIONS', [RPCBrokerV.User.DUZ]);

    if tList.count > 0 then
      if piece(tList[0], '^', 1) <> piece(vDiv, '^', 1) then
        vDiv := tList[0];

    User := sCallV('ORWU USERINFO', [nil]);
    DUZ := piece(User, '^', 1);
    DTIME := StrToInt(piece(User, '^', 8));
    FontSz := 10;
    HLGT := nil;
    MGRFLG := StrToInt(sCallV('CRHD MGR', [DUZ]));
    Mi := MainMenu1.Items[0].Find('Preference Configuration');
    if (MGRFLG > 0) and (Mi <> nil) then
      Mi.Visible := True
    else
      Mi.Visible := False;

    MGRHOTFLG := StrToInt(sCallV('CRHD HOT TEAM MGR', [DUZ]));
    Mi := MainMenu1.Items[0].Find('Hot List Configuration');
    if (MGRHOTFLG > 0) and (Mi <> nil) then
      Mi.Visible := True
    else
      Mi.Visible := False;

    tList.Clear;
    tCallV(tList, 'CRHD DEFAULT PREFERENCE', [DUZ]);
    if tList.count > 0 then
      Pref := tList[0]
    else
      Pref := '';

    if Pref = '' then
    begin
      vList := TStringList.Create;
      try
        vList.Clear;
        Pref := GetList('CRHD AVAILABLE PARAMETERS', 3);
        if (Pref <> '') AND (piece(Pref, '^', 4) <> 'DEF') then
        begin
          // save selected preference as the default preference
          vList.Add(piece(Pref, '^', 1) + '|' + piece(Pref, '^', 2) + '|' +
            piece(Pref, '^', 3));
          CALLV('CRHD SAVE XPAR PARAMETERS',
            [DUZ + '^' + piece(User, '^', 2) + '^USR',
            'CRHD DEFAULT PREFERENCE', '', vList]);

          vList.Clear;
          tCallV(vList, 'CRHD GET USER PARAMETERS', [Pref]);
          clearparameters;
          SetParameters(vList);
          // frmListSelect.Caption := 'Shift Change Handoff ' + ProjectVersion + '  ' + piece(Pref,'^',3);
          frmListSelect.Caption := ProductName + ' ' + ProjectVersion + '  ' +
            piece(Pref, '^', 3);
        end;
      Finally
        vList.free;
      End;
    end;

    // allow change preference if more than one exist.
    EnableChgPreferenceMenu;

    frmListSelect.FormStyle := fsNormal;
  finally
    tList.free;
  end;
end;

procedure TfrmListSelect.FormDestroy(Sender: TObject);
begin
 if Assigned(UserPar.RESIDENT) then FreeAndNil(UserPar.RESIDENT);
 if Assigned(UserPar.STUDENT) then FreeAndNil(UserPar.STUDENT);
 if Assigned(UserPar.DNR_Titles) then FreeAndNil(UserPar.DNR_Titles);
 if Assigned(HOAddPats) then FreeAndNil(HOAddPats);
 if Assigned(SelectedList) then FreeAndNil(SelectedList);
end;

function TfrmListSelect.IsVersionOK: boolean;
Const
  MisMatchMsg = 'This running version of Shift Change Handoff (%s) is not compatible with the current server software (%s). ' +
   'Please contact local support staff to obtain a compatible version of the GUI';
var
 ReqVer: String;
begin
 // ProjectVersion := FileVersionValue(Application.ExeName, FILE_VER_FILEVERSION);
  ReqVer := sCallV('CRHD GET XPAR PARAM', ['CRHD GUI VERSION']);
  if (VersionOK(ProjectVersion, ReqVer) <> True) then
  begin
    TaskMessageDlg('Version Mismatch', Format(MisMatchMsg, [ProjectVersion, ReqVer]), mtError,[mbok],0);
    Result := false;
  end else
   Result := true;
end;

procedure TfrmListSelect.cbNewPersonalListClick(Sender: TObject);
var
 newlist: string;
 newlistnum: integer;
 i : integer;
 flg : Boolean;
begin
if cbNewPersonalList.Checked = True then
      begin
      cbOneTime.Enabled := False;
      cbSavePersonalList.Enabled := False;
      cbSaveHOTeamList.Enabled := False;
      cbSavePersonalList.Checked := False;
      pnlChgListOption.Visible := False;

      DialogOptionsNewList(font.size,  newlist);
      if newlist = '' then
     begin
      cbNewPersonalList.Checked := False;
      cbNewPersonalList.Enabled := False;
      pnlChgListOption.Visible := False;
      end
      else
      begin
      newlistnum := strtointdef(Piece(newlist, '^', 1), 0);
      if newlistnum > 0 then
      rpcSaveListChanges(ORLbxPatients.Items, newlistnum);
      cboPList.Items.Clear;
      rpcGetPersonalLists(cboPList.Items);
      cbNewPersonalList.Enabled := False;
      flg := False;
      i := 0;
      while not flg do
        begin
          if piece(cboPList.Items[i],'^',1) = piece(newlist,'^',1) then
            begin
              flg := True;
              cboPList.ItemIndex := i;
            end
            else inc(i);

           if (not flg) and (i = cboPList.Items.Count) then flg := True;
        end;

    Changelblcolor(HLGT, btn_Personal);
    ORLbxPatients.Clear;
    ListPtByTeam(ORLbxPatients.Items, StrToInt(piece(cboPList.items[cboPList.ItemIndex],'^',1))) ;

    Edit1.Text := 'Personal';
    Edit2.Text := Piece(newlist, '^', 2);
    if Not cboPList.Visible then
      begin
      cboPList.Visible := True;
      cboPList.setfocus;
      end;

    btnSubmit.Enabled := PatientsFound;
    btnClearList.Enabled := PatientsFound;
    end;

end;
end;

procedure TfrmListSelect.cbNewPersonalListKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_RETURN then
begin
 (Sender as TCheckBox).Checked := True;
 (Sender as TCheckBox).OnClick((Sender as TCheckBox));
end;
end;

procedure TfrmListSelect.cbOneTimeClick(Sender: TObject);
var
  newlist: string;
  newlistnum: integer;
  newlistName : String;
  f : Boolean;
  oldList : String;
begin
   f := False;
   if cbOneTime.Checked then
    begin
      cbNewPersonalList.Enabled := False;
      cbSavePersonalList.Enabled := False;
      cbSaveHOTeamList.Enabled := False;
      cbOneTime.Checked := False;
      pnlChgListOption.Visible := False;

      //check for sensitive patients
      if  ((ORLbxPatients.Items.Count > 0 ) and (Pos('No Patients Found',ORLbxPatients.DisplayText[0]) = 0 )) then
       CheckForSensPat(ORLbxPatients.Items);

      if CurrentPtLst <> '' then OldList := CurrentPtLst;

      newlistName := 'TEMP' + DateTimeToStr(Now);
      newList := rpcNewList(newlistName);
      TMP_LST := newlist;
      newlistnum := strtointdef(Piece(newlist, '^', 1), 0);
      if newlistnum > 0 then
       begin
        rpcSaveListChanges(ORLbxPatients.Items, newlistnum);
        CurrentPtLst := Newlist;
       end;
      SelectList(CurrentPtLst, '^P',ORLbxPatients.Items, f, ORLbxPatients.ItemIndex);
      cbOneTime.Checked := False;
      //rbOneTime.Visible := False;
      rpcGetPersonalLists(cboPList.Items);
      cboPList.ItemIndex := cboPList.Items.IndexOf(Piece(newlist, '^', 1));
      Changelblcolor(HLGT, btn_Personal);
      Edit1.Text := 'Personal';
      Edit2.Text := '';
      ORLbxPatients.Items.Clear;
      PatientsFound := False;
      btnSubmit.Enabled := PatientsFound;
      btnClearList.Enabled := PatientsFound;
    end;
    CurrentPtLst := OldList;
end;

procedure TfrmListSelect.cboPListClick(Sender: TObject);
var
  tList: TStrings;
  s: String;
  Mi: TMenuItem;
begin
  tList := TStringList.Create;
  try
    LastPatientAdd := '';
    if not DONOTHING then
    begin

      if cboPList.ItemIndex > -1 then
      begin
        case (HLGT as TButton).Tag of
          1:
            begin
              CurrentPtLst := cboPList.Items[cboPList.ItemIndex];
              ListPtByTeam(tList,
                StrToInt(piece(cboPList.Items[cboPList.ItemIndex], '^', 1)));
              Edit2.Text :=
                piece((Sender as TORComboBox).Items[(Sender as TORComboBox)
                .ItemIndex], '^', 2);
              DeletePL.Items[0].Visible := True;
            end;
          2:
            begin
              CurrentPtLst := cboPList.Items[cboPList.ItemIndex];
              ListPtByWard(tList,
                StrToInt(piece(cboPList.Items[cboPList.ItemIndex], '^', 1)));
              Edit2.Text :=
                piece((Sender as TORComboBox).Items[(Sender as TORComboBox)
                .ItemIndex], '^', 2);
            end;
          3:
            begin
              CurrentPtLst := cboPList.Items[cboPList.ItemIndex];
              ListPtByProvider(tList,
                StrToInt64(piece(cboPList.Items[cboPList.ItemIndex], '^', 1)));
              Edit2.Text :=
                piece((Sender as TORComboBox).Items[(Sender as TORComboBox)
                .ItemIndex], '^', 2);
            end;
          4:
            begin
              begin
                if ORLbxPatients.Items.count = 1 then
                  if (piece(ORLbxPatients.Items[0], '^', 1) = '') or
                    (piece(ORLbxPatients.Items[0], '^', 1) = 'No Patients Found')
                  then
                    ORLbxPatients.Items.Clear;
                if (Not findDup(piece(cboPList.Items[cboPList.ItemIndex], '^',
                  1), ORLbxPatients.Items)) then
                  ORLbxPatients.ItemIndex :=
                    ORLbxPatients.Items.Add(cboPList.Items[cboPList.ItemIndex]);
                ListModified := True;
                if piece(CurrentPtLst, '^', 3) = 'HOTEAM' then
                begin
                  if (not cbSaveHOTeamList.Enabled) then
                  begin
                    s := sCallV('CRHD HOT CAN EDIT', [CurrentPtLst, DUZ]);
                    if piece(s, '^', 1) = '1' then
                    begin
                      SaveOptions(CurrentPtLst);
                      if HOAddPats = nil then
                        HOAddPats := TStringList.Create;
                      HOAddPats.Add(cboPList.Items[cboPList.ItemIndex]);
                    end
                    else
                    begin
                      SaveOptions(CurrentPtLst);
                    end;
                  end
                  else
                    HOAddPats.Add(cboPList.Items[cboPList.ItemIndex]);
                end
                else
                  SaveOptions(CurrentPtLst);
                PatientsFound := True;
              end;
            end;
          5:
            begin
              CurrentPtLst := cboPList.Items[cboPList.ItemIndex];
              ListPtByTeam(tList,
                StrToInt(piece(cboPList.Items[cboPList.ItemIndex], '^', 1)));
              Edit2.Text :=
                piece((Sender as TORComboBox).Items[(Sender as TORComboBox)
                .ItemIndex], '^', 2);
            end;
          6:
            begin
              CurrentPtLst := cboPList.Items[cboPList.ItemIndex];
              ListPtBySpecialty(tList,
                StrToInt(piece(cboPList.Items[cboPList.ItemIndex], '^', 1)));
              Edit2.Text :=
                piece((Sender as TORComboBox).Items[(Sender as TORComboBox)
                .ItemIndex], '^', 2);
            end;
          7:
            begin
              if Pos('^HOT', cboPList.Items[cboPList.ItemIndex]) < 1 then
                cboPList.Items[cboPList.ItemIndex] :=
                  cboPList.Items[cboPList.ItemIndex] + '^HOT';
              CurrentPtLst := cboPList.Items[cboPList.ItemIndex];
              tCallV(tList, 'CRHD HOT PATIENT LIST', [CurrentPtLst]);
              if tList.count = 0 then
                PatientsFound := False;
              Edit2.Text :=
                piece((Sender as TORComboBox).Items[(Sender as TORComboBox)
                .ItemIndex], '^', 2);

              Mi := DeletePL.Items[0];
              if (MGRHOTFLG > 0) and (Mi <> nil) then
                Mi.Visible := True
              else
                Mi.Visible := False;
            end;
        end;
        if tList.count > 0 then
        begin
          Edit2.Enabled := True;
          ORLbxPatients.Enabled := True;
          ORLbxPatients.Items := tList;
          if piece(tList[0], '^', 1) = '' then
            PatientsFound := False
          else
            PatientsFound := True;
        end;
        btnSubmit.Enabled := PatientsFound;
        btnClearList.Enabled := PatientsFound;
      end;
    end;
  finally
    tList.free;
  end;
end;

procedure TfrmListSelect.SelectList(LN, TL: String; Patients : TStrings; f: Boolean; indx: integer);
begin
  if SelectedList = nil then SelectedList := TStringList.Create;
  SelectedList.Clear;
  If Patients.count=0 then exit;

  if ORLbxPatients.Items.Count = 0 then
   begin
    cboPList.Text := '';
    CurrentPtLst :='';
    PatientsFound := False;
    btnSubmit.Enabled := PatientsFound;
    btnClearList.Enabled := PatientsFound;
   end
  else
   begin
    PatientsFound := True;
    btnSubmit.Enabled := PatientsFound;
    btnClearList.Enabled := PatientsFound;
   end;

  Screen.Cursor := crDefault;

  if indx <0 then indx := 0;

  PrintDataList(Patients, LN, Pref, indx);
  SelectedList.Clear;

    if TMP_LST <> '' then
     begin
      rpcDeleteList(piece(TMP_LST,'^',1));
      if Edit1.Text = 'Personal' then
       begin
        cboPList.Clear;
        btn_PersonalClick(btn_Personal) ;
       end;
      TMP_LST := '';
     end;

end;

procedure TfrmListSelect.cboPListDblClick(Sender: TObject);
var
f : Boolean;
begin
  f := false;
  ClearAllRadioButtons;

  if  ((HLGT as TButton).Name <> 'btn_Def_Patient') and (cboPList.ItemIndex < 0)  then
   begin
     LastPatientAdd := '';
     if (cboPList.ItemIndex < 0)then
       begin
         PatientsFound := False;
         ShowMessage('List not selected');
       end;
   end;

  if HLGT <> btn_Patient then
    if (ORLbxPatients.Items.Count=0) or
       ((ORLbxPatients.Items.Count = 1 ) and (Pos('No Patients Found',ORLbxPatients.DisplayText[0]) > 0 )) then
    begin
      PatientsFound := False;
      ShowMessage('Patient List is empty');
    end;

  //check for sensitive patients
  if ((ORLbxPatients.Items.Count > 0 ) and (Pos('No Patients Found',ORLbxPatients.DisplayText[0]) = 0 )) then
   CheckForSensPat(ORLbxPatients.Items);

  if PatientsFound = True then
    case (HLGT as TButton).Tag of
        0: SelectList(DfltPtList + '^' + DfltPtList, '^PATLIST', ORLbxPatients.Items, f, ORLbxPatients.ItemIndex);
        1: SelectList(cboPList.items[cboPList.ItemIndex],'P' ,ORLbxPatients.Items, f, ORLbxPatients.ItemIndex);
        2: SelectList(cboPList.items[cboPlist.ItemIndex],'^WARD',ORLbxPatients.Items , f, ORLbxPatients.ItemIndex);
        3: SelectList(cboPList.items[cboPList.ItemIndex], '^PROVIDER', ORLbxPatients.Items, f, ORLbxPatients.ItemIndex);
        4: begin
            SaveOptions(CurrentPtLst);
            ListModified := True;
            PatientsFound := True;
            btnSubmit.Enabled := PatientsFound;
            btnClearList.Enabled := PatientsFound;
           end;
        5: SelectList(cboPList.items[cboPList.ItemIndex],'^TEAM' ,ORLbxPatients.Items, f, ORLbxPatients.ItemIndex);
        6: SelectList(cboPlist.items[cboPlist.ItemIndex],'^SPECIALTY',ORLbxPatients.Items , f, ORLbxPatients.ItemIndex);
        7: SelectList(cboPlist.items[cboPlist.ItemIndex],'^HOT',ORLbxPatients.Items , f, ORLbxPatients.ItemIndex);
     end;
  cboPListClick(sender);
end;

procedure TfrmListSelect.cboPListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   case Key of
       VK_LEFT..VK_DOWN  : DONOTHING := TRUE;
       else
        DONOTHING := FALSE;
   end;
end;

procedure TfrmListSelect.cboPListKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if (Key = VK_RETURN)and (cboPList.Text='') then (HLGT as TButton).SetFocus;
end;

procedure TfrmListSelect.cboPListMouseClick(Sender: TObject);
begin
DONOTHING := False;
end;

procedure TfrmListSelect.cboPListNeedData(Sender: TObject;
  const StartFrom: String; Direction, InsertAt: Integer);
  procedure ShowMatchingPatients;
    begin
      with ORLbxPatients do
        begin
          if ShortCount > 0 then
            begin
              if ShortCount = 1 then
                begin
                  ItemIndex := 0;
                end;
              Items.Add(LLS_LINE);
              Items.Add(LLS_SPACE);
            end;
          InitLongList('');
        end;
    end;


begin
  if (HLGT as TButton).tag = 3 then cboPList.ForDataUse(SubSetOfProviders(StartFrom, Direction));
  if (HLGT as TButton).tag = 4 then
   begin
    with cboPList do
      if IsLast5(Text) then
       begin
        ListPtByLast5(Items, Text);
        ShowMatchingPatients;
       end
      else if IsFullSSN(Text) then
       begin
        ListPtByFullSSN(Items, Text);
        ShowMatchingPatients;
       end
  else
   cboPList.ForDataUse(SubSetOfPatients(StartFrom, Direction));
  end;
end;

procedure TfrmListSelect.cbSaveHOTeamListClick(Sender: TObject);
begin
if HOAddPats.Count > 0 then
 begin
   CallV('CRHD HOT MODIFY LIST', [CurrentPtLst, 'P', HOAddPats, '0']);
   SelectList(CurrentPtLst,'^HOTEAM',ORLbxPatients.Items , False, ORLbxPatients.ItemIndex);
   HOAddPats.Clear;
   ClearAllRadioButtons;
   ListModified := False;
   ORLbxPatients.Clear;
   cboPList.Clear;
   btnSubmit.Enabled := False;
   btn_HOList.OnClick(btn_HOList);
 end;
end;

procedure TfrmListSelect.cbSavePersonalListClick(Sender: TObject);
var
newlistnum: integer;
begin
    if cbSavePersonalList.Checked = True then
    begin
   ClearAllRadioButtons;
   newlistnum := strtointdef(Piece(CurrentPtLst, '^', 1), 0);
   if newlistnum > 0 then
   if (piece(CurrentPtLst,'^',1) <> '') and (ORLbxPatients.items.Count>0) then
   rpcSaveListChanges(ORLbxPatients.Items, StrToInt(piece(CurrentPtLst,'^',1)));
   cbSavePersonalList.Checked := False;
   rpcGetPersonalLists(cboPList.Items);
   cboPList.ItemIndex := cboPList.Items.IndexOf(Piece(CurrentPtLst, '^', 1));
   Changelblcolor(HLGT, btn_Personal);
   Edit1.Text := 'Personal';
   Edit2.Text := '';
   if cboPList.itemIndex > -1 then btnSubmit.Enabled := PatientsFound
   else btnSubmit.Enabled := False;

   btnClearList.Enabled := PatientsFound;
end;
end;

procedure TfrmListSelect.FormShow(Sender: TObject);
var
  tList: TStrings;
begin
  if User = '' then
    Close;

  HLGT := btn_Def_Patient;
  with (HLGT as TButton) do
  begin
    setfocus;
    font.Color := clRed;
    Edit2.Text := piece((HLGT as TButton).Caption, '&', 1) +
      piece((HLGT as TButton).Caption, '&', 2);
    OnClick(Sender);
  end;

  tList := TStringList.Create;
  try
    tList.Clear;

    if Pref <> '' then
      tCallV(tList, 'CRHD GET USER PARAMETERS', [Pref])
    else
      tCallV(tList, 'CRHD ALL USER PARAMETERS',
        [DUZ, piece(frmListSelect.vDiv, '^', 1)]);
    clearparameters;

    SetParameters(tList);
    tList.Clear;
    frmListSelect.Caption := ProductName + ' ' + ProjectVersion + '  ' +
      piece(Pref, '^', 3);
    tCallV(tList, 'CRHD GET DNR TITLES',
      [DUZ, piece(frmListSelect.vDiv, '^', 1)]);
    if tList.count > 0 then
      UserPar.DNR_Titles.AddStrings(tList);

    if TMP_LST <> '' then
    begin
      rpcDeleteList(piece(TMP_LST, '^', 1));
      TMP_LST := '';
    end;
  finally
    tList.free;
  end;
end;

 procedure TfrmListSelect.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmListSelect.DeletePLPopup(Sender: TObject);
var
mi : TMenuItem;
begin
 if cboPList.ItemIndex < 0 then
  begin
   mi := DeletePL.Items.Find('Delete List');
   mi.Enabled := False;

   mi := DeletePL.Items.Find('Assign Providers to Team/List');
   mi.Enabled := False;

   mi := DeletePL.Items.Find('Get Additional Info');
   mi.Enabled := False;
  end
 else
  begin
   mi := DeletePL.Items.Find('Delete List');
   if ((HLGT as TButton).Tag = 1)or ((HLGT as TButton).Tag = 7) then mi.Enabled := True
   else mi.Enabled := False;

   mi := DeletePL.Items.Find('Assign Providers to Team/List');
   if ((HLGT as TButton).Tag = 4) or((HLGT as TButton).Tag = 0) then mi.Enabled := False
   else mi.Enabled := True;

   mi := DeletePL.Items.Find('Get Additional Info');
   if ((HLGT as TButton).Tag = 4) or ((HLGT as TButton).Tag = 3)or((HLGT as TButton).Tag = 0) then mi.Enabled := False
   else mi.Enabled := True;
  end;
end;

procedure TfrmListSelect.DeletePersonalListClick(Sender: TObject);
var
i : integer;
vstr : String;
begin
 if ((HLGT as TButton).Name = 'btn_Personal') or ((HLGT as TButton).Name ='btn_HOList') and (cboPList.itemindex > -1) then
 begin
   i := CurrentIndex(cboPList.itemindex, cboPList.items.count);
  if (HLGT as TButton).Name = 'btn_Personal' then rpcDeleteList(piece(cboPList.items[cboPList.itemindex],'^',1));
  if (HLGT as TButton).Name = 'btn_HOList' then
     begin
       vstr := sCallV('CRHD HOT DELETE TEAM LIST', [cboPList.items[cboPList.itemindex]]);
     end;
  cboPList.Items.Delete(cboPList.itemindex);
  cboPList.Text := '';
  Edit2.Text := '';
  ORLbxPatients.Items.clear;
  cboPList.itemindex := i;
  if cboPList.itemIndex > -1 then
  CurrentPtLst := cboPList.Items[cboPList.itemIndex]
  else CurrentPtLst := '';
 end;
end;

procedure TfrmListSelect.SetParameters(TL: TStrings);
var
i : integer;

begin
Clearparameters;

if UserPar.RESIDENT = nil then UserPar.RESIDENT := TStringList.Create;
   UserPar.RESIDENT.Clear;

if UserPar.STUDENT = nil then UserPar.STUDENT := TStringlist.Create;
   UserPar.STUDENT.Clear;

if UserPar.DNR_Titles = nil then UserPar.DNR_Titles := TStringlist.Create;
   UserPar.DNR_Titles.Clear;

   UserPar.MED_DETAIL_FLG := 1;

    for i := 0 to TL.count -1 do
      begin
        if  pos('TEMP_FLD_1_TITLE',piece(TL[i],'^',1))> 0 then UserPar.TEMP_FLD_1_TITLE := piece(TL[i],'^',2);
        if  pos('TEMP_FLD_1_SIZE',piece(TL[i],'^',1))> 0 then UserPar.TEMP_FLD_1_SIZE := piece(TL[i],'^',2);

        if  pos('TEMP_FLD_2_TITLE',piece(TL[i],'^',1))> 0 then UserPar.TEMP_FLD_2_TITLE := piece(TL[i],'^',2);
        if  pos('TEMP_FLD_2_SIZE',piece(TL[i],'^',1))> 0  then UserPar.TEMP_FLD_2_SIZE := piece(TL[i],'^',2);

        if  pos('TEMP_FLD_3_TITLE',piece(TL[i],'^',1))> 0 then UserPar.TEMP_FLD_3_TITLE := piece(TL[i],'^',2);
        if  pos('TEMP_FLD_3_SIZE',piece(TL[i],'^',1))> 0  then UserPar.TEMP_FLD_3_SIZE := piece(TL[i],'^',2);

        if  pos('TEMP_FLD_4_TITLE',piece(TL[i],'^',1))> 0  then UserPar.TEMP_FLD_4_TITLE := piece(TL[i],'^',2);
        if  pos('TEMP_FLD_4_SIZE',piece(TL[i],'^',1))> 0 then UserPar.TEMP_FLD_4_SIZE := piece(TL[i],'^',2);

        if  pos('TEMP_FLD_COLOR',piece(TL[i],'^',1))> 0 then UserPar.TEMP_FLD_COLOR := piece(TL[i],'^',2);
        if  pos('TEMP_FLD_FONTCOLOR',piece(TL[i],'^',1))> 0 then UserPar.TEMP_FLD_FONTCOLOR := piece(TL[i],'^',2);

        if  pos('PATIENT_DEMOGRAPHICS',piece(TL[i],'^',1))> 0 then UserPar.PATIENT_DEMOGRAPHICS := piece(TL[i],'^',2);
        if  pos('PATIENT_DEMO_PRINTLBL',piece(TL[i],'^',1))> 0 then UserPar.PATIENT_DEMO_PRINTLBL := StrToInt(piece(TL[i],'^',2));
        if  pos('CONSULTS',piece(TL[i],'^',1))> 0  then UserPar.CONSULTS:= StrToInt(piece(TL[i],'^',2));
        if  pos('LABS_IMAGING',piece(TL[i],'^',1))> 0  then UserPar.LABS_IMAGING := StrToInt(piece(TL[i],'^',2));
        if  pos('RESIDENT',piece(TL[i],'^',1))> 0  then UserPar.RESIDENT.Add(piece(TL[i],'^',2));
        if  pos('STUDENT',piece(TL[i],'^',1))> 0 then UserPar.STUDENT.Add(piece(TL[i],'^',2));
        if  pos('MED_DETAIL_FLG',piece(TL[i],'^',1))> 0 then  UserPar.MED_DETAIL_FLG :=StrToInt(piece(TL[i],'^',2));
        if  pos('MED_EXCLUDE_IV',piece(TL[i],'^',1))> 0 then  UserPar.MED_EXCLUDE_IV :=StrToInt(piece(TL[i],'^',2));
        if  pos('PRINT_ORIENTATION',piece(TL[i],'^',1))> 0 then  UserPar.PRINT_ORIENTATION :=piece(TL[i],'^',2);
        if  pos('ORDER_BY',piece(TL[i],'^',1))> 0 then  UserPar.ORDER_BY :=StrToInt(piece(TL[i],'^',2));
        if  pos('MULTI_DNR',piece(TL[i],'^',1))> 0 then UserPar.MULTI_DNR := StrToInt(piece(TL[i],'^',2));
        if  pos('FILE_Location',piece(TL[i],'^',1))>0  then UserPar.FILE_Location := piece(TL[i],'^',2);

      end;
end;

procedure TfrmListSelect.Preference1Click(Sender: TObject);
var
  vList: TStrings;
begin
  Preferences;
  vList := TStringList.Create;
  try
    tCallV(vList, 'CRHD GET USER PARAMETERS', [Pref]);
    clearparameters;
    SetParameters(vList);
  finally
    vList.free;
  end;
end;

procedure TfrmListSelect.Changelblcolor(C1, C2: TControl);
begin
//if (C1 as TButton) <> nil then (C1 as TButton).Font.color := clBlack;
//if (C2 as TButton) <> nil then
//  begin
//   (C2 as TButton).Font.color := clRed;
    HLGT2 := (C1 as TButton);
    HLGT := (C2 as TButton);
//  end;
//    (C2 as TButton).Repaint;

end;

procedure TfrmListSelect.ORLbxPatientsDblClick(Sender: TObject);
var
idx : integer;
str : string;
begin
if PatientsFound then
  if  ORLbxPatients.ItemIndex > -1 then
  begin
    idx := CurrentIndex(ORLbxPatients.ItemIndex,ORLbxPatients.Items.count );   //ORLbxPatients.ItemIndex;
     if pos('^HOTEAM',CurrentPtLst)>0 then
      begin
      //check to see if user can modify list
        str := sCallV('CRHD HOT CAN EDIT',[CurrentPtLst,DUZ]);
        if piece(str,'^',1)= '1' then
         if MessageDlg('Do you want to delete this patient permanently from the List?',
             mtConfirmation, [mbYes, mbNo], 0) = mrYes then
         str := sCallV('CRHD HOT DELETE PAT/PRV',[CurrentPtLst, 'P', ORLbxPatients.Items[ORLbxPatients.ItemIndex]])
         else
          exit;
      end
      else
      begin
        ListModified := True;
        pnlChgListOption.Visible :=True;
        cbOneTime.Enabled := True;
        cbNewPersonalList.Enabled := True;
        cbSaveHOTeamList.Visible := False;
        cbSavePersonalList.Visible := False;
         pnlchgListOption.SetFocus;
         if piece(CurrentPtLst,'^',3)= 'P' then cbSavePersonalList.Visible := True;
      end;
     //showmessage('Patient:' + piece(ORLbxPatients.Items[ORLbxPatients.ItemIndex],'^',2) + ' will be deleted from list');
     if MessageDlg('Patient:' + piece(ORLbxPatients.Items[ORLbxPatients.ItemIndex],'^',2) + ' will be deleted from list',
             mtConfirmation, [mbYes, mbNo], 0) = mrYes then
             begin
              ORLbxPatients.Items.Delete(ORLbxPatients.ItemIndex);
              ORLbxPatients.ItemIndex := idx;
             end;

      if ORLbxPatients.Items.Count = 0 then
       begin
        pnlChgListOption.Visible := False;
        cbOneTime.Checked := False;
        cbOneTime.Enabled := False;
        ListModified := False;
        cbNewPersonalList.Checked := False;
        cbNewPersonalList.Enabled := False;
        cbSavePersonalList.Checked := False;
        cbSavePersonalList.Enabled := False;
        cbSaveHOTeamList.Checked := False;
        cbSaveHOTeamList.Enabled := False;
        btnSubmit.Enabled := False;
      end;
end;

end;

procedure TfrmListSelect.ORLbxPatientsKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = #13 then
    ORLbxPatientsDblClick(Sender);
  ORLbxPatients.SetFocus;
end;

procedure TfrmListSelect.CheckForSensPat(PatList: TStrings);
Var
  i, AccessStatus: Integer;
  TempList: TstringList;
begin
 //we will check here and remove if needed
 TempList := TstringList.Create();
 try

  //Do we need to remove any patients?
  for i := 0 to PatList.Count - 1 do begin
   if AllowAccessToSensitivePatient(Piece(PatList.Strings[i], '^', 1), Piece(PatList.Strings[i], '^', 2), AccessStatus) then
    TempList.Add(PatList.Strings[i]);
  end;

  //Now Update the list
  PatList.Assign(TempList);

 finally
  TempList.Free;
 end;
end;


procedure TfrmListSelect.clearparameters;
begin
if UserPar.RESIDENT = nil then UserPar.RESIDENT := TStringList.Create;
if UserPar.STUDENT = nil then UserPar.STUDENT := TStringlist.Create;
if UserPar.DNR_Titles = nil then UserPar.DNR_Titles := TStringlist.Create;

with UserPar do
begin
TEMP_FLD_1_TITLE       :='';
  TEMP_FLD_EXPIRE      :=0;
  TEMP_FLD_1_SIZE      :='';

  TEMP_FLD_2_TITLE     :='';
  TEMP_FLD_2_SIZE      :='';

  TEMP_FLD_3_TITLE     :='';
  TEMP_FLD_3_SIZE      :='';

  TEMP_FLD_4_TITLE     :='';
  TEMP_FLD_4_SIZE      :='';

  STUDENT.Clear;
  RESIDENT.Clear;
  DNR_Titles.Clear;

  PATIENT_DEMOGRAPHICS :='';
  MED_DETAIL_FLG       :=0;
  MED_EXCLUDE_IV       :=1;
  CONSULTS             :=0;
  LABS_IMAGING         :=0;
  PRINT_ORIENTATION    :='';
  ORDER_BY             :=0;
end;
end;

procedure TfrmListSelect.btnSubmitClick(Sender: TObject);
begin
cboPListDblClick(cboPList);
end;

procedure TfrmListSelect.DeletePatientfromList1Click(Sender: TObject);
begin
ORLbxPatientsDblClick(ORLbxPatients);
end;

procedure TfrmListSelect.btnClearListClick(Sender: TObject);
begin
ORLbxPatients.Items.Clear;
Edit2.Text := '';
with (HLGT as TButton)  do
  begin
   pnlChgListOption.Visible := True;
   pnlchgListOption.SetFocus;
   Font.Color := clRed;
   edit2.Text := 'Patients';
   Changelblcolor(HLGT, btn_Patient);
   cboPList.Visible := True;
   cboPList.Items.Clear;
   cboPList.Text := '';
   edit1.Text := piece((HLGT as TButton).Caption,'&',1)+piece((HLGT as TButton).Caption,'&',2);
   btnSubmit.Enabled := False;
   cbNewPersonalList.Enabled := False;
   cbOneTime.Enabled := False;
   cbSavePersonalList.Enabled := False;
end;


with cboPList do
 begin
  ListItemsOnly := true;
  LongList := true;
  InitLongList('');
 end;
end;

procedure TfrmListSelect.btn_SpecialtyClick(Sender: TObject);
begin
  Changelblcolor(HLGT, btn_Specialty);
  ClearAllRadioButtons;
  cboPList.Visible := True;
  cboPList.Items.Clear;
  cboPList.Text := '';
  edit1.Text := piece((HLGT as TButton).Caption,'&',1)+piece((HLGT as TButton).Caption,'&',2);
  ListSpecialtyAll(cboPList.Items);
end;

procedure TfrmListSelect.btn_SpecialtyKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_TAB then btn_SpecialtyClick(btn_Specialty);
if Key = VK_RETURN then cboPList.SetFocus;

end;

procedure TfrmListSelect.btn_Def_PatientClick(Sender: TObject);
var
Dflist : String;
begin
ORLbxPatients.Items.Clear;

Changelblcolor(HLGT, btn_Def_Patient);
cboPList.Visible := False;
if pnlChgListOption.Visible then pnlChgListOption.Visible := False;

edit1.Text := piece((HLGT as TButton).Caption,'&',1)+piece((HLGT as TButton).Caption,'&',2);

Dflist := sCallV('ORQPT DEFAULT LIST SOURCE', [nil]);
if piece(Dflist,'^',1) <> '' then
  begin
   CurrentPtLst := Dflist;
   Edit2.Text := piece(CurrentPtLst,'^',2);
   tCallV(ORLbxPatients.Items,'CRHD GET PAT LIST',[Dflist + '^' + DfltPtList + '^PATLIST']);
  end
  else
   if piece(Dflist,'^',1) = '' then tCallV(ORLbxPatients.Items,'CRHD GET PAT LIST',['']);


   if ORLbxPatients.Items.Count > 0 then PatientsFound := True
   else
     begin
       ORLbxPatients.Enabled := False;
       edit2.Enabled := False;
      end;

 btnSubmit.Enabled := PatientsFound;
 btnClearList.Enabled := PatientsFound;
end;

procedure TfrmListSelect.btn_Def_PatientKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_TAB then btn_Def_PatientClick(btn_Def_Patient);
end;

procedure TfrmListSelect.btn_HOListClick(Sender: TObject);
begin
Changelblcolor(HLGT, btn_HOList);
ClearAllRadioButtons;
cboPList.Visible := True;
cboPList.Items.Clear;
cboPList.Text := '';
edit1.Text := piece((HLGT as TButton).Caption,'&',1)+piece((HLGT as TButton).Caption,'&',2);
tCallV(cboPList.Items,'CRHD HOT TEAM LIST', [nil]);
end;

procedure TfrmListSelect.btn_HOListKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_TAB then btn_HOListClick(btn_HOList);
if Key = VK_RETURN then cboPList.SetFocus;
end;

procedure TfrmListSelect.btn_PatientClick(Sender: TObject);
begin
  Changelblcolor(HLGT, btn_Patient);
  cboPList.Visible := True;
  cboPList.Items.Clear;
  cboPList.Text := '';
  edit1.Text := piece((HLGT as TButton).Caption,'&',1)+piece((HLGT as TButton).Caption,'&',2);
  with cboPList do
   begin
    ListItemsOnly := true;
    LongList := true;
    InitLongList('');
   end;
   DONOTHING := True;
end;

procedure TfrmListSelect.btn_PatientKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_TAB then btn_PatientClick(btn_Patient);
if Key = VK_RETURN then cboPList.SetFocus;
end;

function TfrmListSelect.IsFullSSN(x: string): Boolean;
var
  i: integer;
begin
  Result := False;
  if (Length(x) < 9) or (Length(x) > 12) then Exit;
  case Length(x) of
    9:  // no dashes, no 'P'
        for i := 1 to 9 do if not CharInSet(x[i], ['0'..'9']) then Exit;
   10:  // no dashes, with 'P'
        begin
          for i := 1 to 9 do if not CharInSet(x[i], ['0'..'9']) then Exit;
          if (Uppercase(x[10]) <> 'P') then Exit;
        end;
   11:  // dashes, no 'P'
        begin
          if (x[4] <> '-') or (x[7] <> '-') then Exit;
          x := Copy(x,1,3) + Copy(x,5,2) + Copy(x,8,4);
          for i := 1 to 9 do if not CharInSet(x[i], ['0'..'9']) then Exit;
        end;
   12:  // dashes, with 'P'
        begin
          if (x[4] <> '-') or (x[7] <> '-') then Exit;
          x := Copy(x,1,3) + Copy(x,5,2) + Copy(x,8,5);
          for i := 1 to 9 do if not CharInSet(x[i], ['0'..'9']) then Exit;
          if UpperCase(x[10]) <> 'P' then Exit;
        end;
  end;
  Result := True;
end;

function TfrmListSelect.IsLast5(x: string): Boolean;
    { returns true if string matchs patterns: A9999 or 9999 (BS & BS5 xrefs for patient lookup) }
var
  i: Integer;
begin
  Result := False;
  if not ((Length(x) = 4) or (Length(x) = 5)) then Exit;
  if Length(x) = 5 then
  begin
    if not CharInSet(x[1], ['A'..'Z', 'a'..'z']) then Exit;
    x := Copy(x, 2, 4);
  end;
  for i := 1 to 4 do if not CharInSet(x[i], ['0'..'9']) then Exit;
  Result := True;
end;

procedure TfrmListSelect.Hand1Click(Sender: TObject);
var
s : String;
MGRkey : Integer;
begin
     if CurrentPtLst <> '' then s := sCallV('CRHD HOT CAN EDIT',[CurrentPtLst,DUZ]);
     MGRkey := StrToInt(sCallV('CRHD HOT TEAM MGR',[DUZ]));
     if (piece(s,'^',1)= '1') or (MGRkey > 0) then  HOTeamSelectP
     else showmessage('You are nt authorized to edit this list');
end;

procedure TfrmListSelect.Content1Click(Sender: TObject);
begin
  //check for network help and download if applicable (non-threaded)
  LoadHelpFile(Application.HelpFile);
  Application.HelpCommand(HELP_CONTENTS, 0);
end;

procedure TfrmListSelect.SaveOptions(SelList: String);
var
s : string;
begin
  pnlChgListOption.Visible := False;
  cbNewPersonalList.Checked := False;
  cbOneTime.Checked := False;
  cbSavePersonalList.Checked := False;
  cbSavePersonalList.Checked := False;

  cbNewPersonalList.Enabled := False;
  cbOneTime.Enabled := False;
  cbSavePersonalList.Enabled := False;
  cbSavePersonalList.Enabled := False;

  if ListModified then
  if (pos('^HOTEAM',SelList) > 0) then
   begin
     s := sCallV('CRHD HOT CAN EDIT',[CurrentPtLst,DUZ]);
     if piece(s,'^',1)= '1' then  cbSaveHOTeamList.Enabled := True
     else cbSaveHOTeamList.Enabled := False;

     pnlChgListOption.Visible := True;
     cbOneTime.Enabled := True;
     cbNewPersonalList.Enabled := True;
     cbSavePersonalList.Enabled := False;
   end
  else
   begin
      pnlChgListOption.Visible := True;
      cbOneTime.Enabled := True;
      cbNewPersonalList.Enabled := True;
      cbSaveHOTeamList.Enabled :=False;
      if piece(CurrentPtLst,'^',3) = 'P' then
      Begin
        cbSavePersonalList.Visible := True;
        cbSavePersonalList.Enabled := True;
      end;
   end;
end;

procedure TfrmListSelect.GetAdditionalInfo1Click(Sender: TObject);
begin
TeamInfo2Click(MainMenu1);
end;

procedure TfrmListSelect.Directory1Click(Sender: TObject);
begin
if DUZ <> '' then TeamPhoneNumbers(DUZ + '^USR');
end;

procedure TfrmListSelect.TeamInfo2Click(Sender: TObject);
begin
DisplayFile(CurrentPtLst);
end;

procedure TfrmListSelect.UpdateMyPref();
var
  pList: String;
  vList: TStrings;
begin
  vList := TStringList.Create;
  try
    vList.Clear;
    pList := GetList('CRHD AVAILABLE PARAMETERS', 3);
    if pList <> '' then
    begin
      tCallV(vList, 'CRHD GET USER PARAMETERS', [pList]);
      clearparameters;
      SetParameters(vList);
      if piece(pList, '^', 1) <> piece(Pref, '^', 1) then
        Pref := pList;
    end;
    frmListSelect.Caption := ProductName + ' ' + ProjectVersion + '  ' +
      piece(Pref, '^', 3);
  finally
    vList.free;
  end;
end;

procedure TfrmListSelect.Email1Click(Sender: TObject);
begin
//ShellExecute(Application.Handle, 'open','mailto:','',nil,SW_NORMAL);
end;

Procedure TfrmListSelect.EnableChgPreferenceMenu;
var
  tList: TStrings;
  Mi: TMenuItem;
begin
  tList := TStringList.Create;
  try
    tCallV(tList, 'CRHD AVAILABLE PARAMETERS', [frmListSelect.DUZ]);
    Mi := MainMenu1.Items[0].Find('Change Preference');
    if (tList.count > 1) and (Mi <> nil) then
      Mi.Visible := True
    else
      Mi.Visible := False;
  finally
    tList.free;
  end;
end;

procedure TfrmListSelect.AssignProvidersClick(Sender: TObject);
begin
if CurrentPtLst <> '' then AssignProvidersToATeam(CurrentPtLst)
else showmessage('List not selected');
end;

procedure TfrmListSelect.btn_PersonalClick(Sender: TObject);
begin
Changelblcolor(HLGT, btn_Personal);
ClearAllRadioButtons;
cboPList.Visible := True;
cboPList.Items.Clear;
cboPList.Text := '';
//get all personal List
edit1.Text := piece((HLGT as TButton).Caption,'&',1)+piece((HLGT as TButton).Caption,'&',2);
rpcGetPersonalLists(cboPList.Items);
end;

procedure TfrmListSelect.btn_PersonalKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_TAB then btn_PersonalClick(btn_Personal);
if Key = VK_RETURN then cboPList.SetFocus;

end;

procedure TfrmListSelect.btn_ProviderClick(Sender: TObject);
begin
  Changelblcolor(HLGT, btn_Provider);
  ClearAllRadioButtons;
  cboPList.Visible := True;
  cboPList.Items.Clear;
  cboPList.Text := '';
  edit1.Text := piece((HLGT as TButton).Caption,'&',1)+piece((HLGT as TButton).Caption,'&',2);
  //populate Provider List
  with cboPList do
   begin
    ListItemsOnly := true;
    LongList := true;
    InitLongList('');
   end;
end;

procedure TfrmListSelect.btn_ProviderKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_TAB then btn_ProviderClick(btn_Provider);
if Key = VK_RETURN then cboPList.SetFocus;
end;

procedure TfrmListSelect.btn_TeamClick(Sender: TObject);
begin
  Changelblcolor(HLGT, btn_Team);
  ClearAllRadioButtons;
  cboPList.Visible := True;
  cboPList.Items.Clear;
  cboPList.Text := '';
  edit1.Text := piece((HLGT as TButton).Caption,'&',1)+piece((HLGT as TButton).Caption,'&',2);
  ListTeamAll(cboPList.Items);
end;

procedure TfrmListSelect.btn_TeamKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_TAB then btn_TeamClick(btn_Team);
if Key = VK_RETURN then cboPList.SetFocus;
end;

procedure TfrmListSelect.btn_WardClick(Sender: TObject);
var
  tList: TStrings;
begin
  tList := TStringList.Create;
  try
    tList.Clear;
    Changelblcolor(HLGT, btn_Ward);
    ClearAllRadioButtons;
    cboPList.Visible := True;
    cboPList.Items.Clear;
    cboPList.Text := '';
    Edit1.Text := piece((HLGT as TButton).Caption, '&', 1) +
      piece((HLGT as TButton).Caption, '&', 2);
    // populate Ward List
    with cboPList do
    begin
      ListItemsOnly := False;
      LongList := False;
      ListWardAll(cboPList.Items);
    end;
  finally
    tList.free;
  end;
end;

procedure TfrmListSelect.btn_WardKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_TAB then btn_WardClick(btn_Ward);
if Key = VK_RETURN then cboPList.SetFocus;
end;

procedure TfrmListSelect.ChangePreference1Click(Sender: TObject);
var
  pList: String;
  vList: TStrings;
begin
  vList := TStringList.Create;
  try
    vList.Clear;
    pList := GetList('CRHD AVAILABLE PARAMETERS', 3);
    if pList <> '' then
    begin
      tCallV(vList, 'CRHD GET USER PARAMETERS', [pList]);
      clearparameters;
      SetParameters(vList);
      if piece(pList, '^', 1) <> piece(Pref, '^', 1) then
      begin
        Pref := pList;
        if MessageDlg('Would you like to save this as your Default Preference?',
          mtConfirmation, [mbYes, mbNo], 0) = mrYes then
        begin
          // Pref := pList;
          if piece(Pref, '^', 4) <> 'D' then
            Pref := Pref + '^' + 'D';
          vList.Clear;
          vList.Add(piece(Pref, '^', 1) + '|' + piece(Pref, '^', 2) + '|' +
            piece(Pref, '^', 3));
          CALLV('CRHD SAVE XPAR PARAMETERS',
            [DUZ + '^' + piece(User, '^', 2) + '^USR',
            'CRHD DEFAULT PREFERENCE', '', vList]);
        end;
      end;
    end;
    frmListSelect.Caption := ProductName + ' ' + ProjectVersion + '  ' +
      piece(Pref, '^', 3);
  finally
    vList.free;
  end;
end;

procedure TfrmListSelect.File1Click(Sender: TObject);
var
mi : TMenuItem;
begin
  mi := File1.Items[1];
  if ((HLGT as TButton).Tag = 0)or ((HLGT as TButton).Tag = 7)or((HLGT as TButton).Tag = 4)or (CurrentPtLst ='') then mi.Enabled := False
  else mi.Enabled := True;
end;

procedure TfrmListSelect.ClearAllRadioButtons;
begin
  cbSaveHOTeamList.Checked := False;
  cbSaveHOTeamList.Enabled := False;

  cbNewPersonalList.Checked := False;
  cbNewPersonalList.Enabled := False;

  cbOneTime.Checked := False;
  cbOneTime.Enabled := False;

  cbSavePersonalList.Checked := False;
  cbSavePersonalList.Enabled := False;

  pnlChgListOption.Visible := False;
end;


procedure TfrmListSelect.About1Click(Sender: TObject);
var
frmAbout : TfrmAbout1;
begin
  frmAbout := TfrmAbout1.Create(Application);
  frmAbout.ShowModal;
  frmAbout.Free;
end;

procedure TfrmListSelect.N8pt1Click(Sender: TObject);
begin
with Sender as TMenuItem do ChangeFont(Tag);
end;

procedure TfrmListSelect.Font1Click(Sender: TObject);
var
i :integer;
begin
 for i := 0 to  Font1.Count-1 do
     if Font1.Items[i].Checked = True then Font1.Items[i].Checked := False;

with Sender as TMenuItem do
 begin
  ChangeFont(Tag);
  checked := True;
  FontSz := Tag;
 end;
end;

procedure TfrmListSelect.ChangeFont(NewFontSize: Integer);
{ Makes changes in all components whenever the font size is changed.  This is hardcoded and
  based on MS Sans Serif for now, as only the font size may be selected. Courier New is used
  wherever non-proportional fonts are required. }
const

  TAB_VOFFSET = 7;
var
  OldFont: TFont;
begin
  OldFont := TFont.Create;
  try
    DisableAlign;
    try
      OldFont.Assign(Font);
      with Self                do Font.Size := NewFontSize;
      with btn_Def_Patient     do Font.Size := NewFontSize;   // must change BOLDED labels by hand
      with btn_Personal        do Font.Size := NewFontSize;
      with btn_Ward            do Font.Size := NewFontSize;
      with btn_Provider        do Font.Size := NewFontSize;
      with btn_Team            do Font.Size := NewFontSize;
      with btn_Specialty       do Font.Size := NewFontSize;
      with btn_HOList          do Font.Size := NewFontSize;
      with btn_Patient         do Font.Size := NewFontSize;
      with cbSaveHOTeamList    do Font.Size := NewFontSize;
      with cbNewPersonalList   do Font.Size := NewFontSize;
      with cbOneTime           do Font.Size := NewFontSize;
      with cbSavePersonalList  do Font.Size := NewFontSize;
      with btnSubmit           do Font.Size := NewFontSize;   //submit button
      with btnClearList        do Font.Size := NewFontSize;   //clear patient list button
      with Edit1               do Font.Size := NewFontSize;
      with Edit2               do Font.Size := NewFontSize;

     cboPList.Font.Size := NewFontSize;
     ORLbxPatients.Font.Size := NewFontSize;

      case NewFontSize of
         8 : Font.Height := -11;
         10 : Font.Height := -13;
         12 : Font.Height := -16;
         18 : Font.Height := -24;
         24 : Font.Height := -32;
      end;

    finally
      EnableAlign;
    end;
  finally
    OldFont.Free;
  end;
end;

initialization

  SpecifyFormIsNotADialog(TfrmListSelect);


end.
